# TP 2 TS326

import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.model_selection import StratifiedShuffleSplit
from sklearn.svm import SVC
from sklearn.metrics import accuracy_score

plt.close('all')

# Lecture des données d'apprentissage
XA = np.load('X_apprentissage.npy').astype('float32')
YA = np.load('Y_apprentissage.npy').astype('int64')
NbAttributs = 2
XA = XA[:, 0:NbAttributs]
NA = XA.shape[0] #Nombre d'échantillons d'apprentissage
Classes = np.unique(YA)
Nb_classes = np.unique(YA).shape[0] #Nombre de classes

#% Lecture des données de test                            
XT = np.load('X_test.npy').astype('float32')
YT = np.load('Y_test.npy').astype('int64')
XT = XT[:, 0:NbAttributs]
NT = XT.shape[0] # Nombre d'échantillons de test

#SVM
# define the SVM classifier with a Radial Basis Function (RBF) kernel.
classifier = SVC(C = 0.1000, kernel="linear",  random_state=0)
# train the classifier and keep track of the time for training.
classifier.fit(XA, YA.ravel())
#prediction over test data
Y_pred = classifier.predict(XT)
#evlauation of the performance
accuracy = accuracy_score(YT, Y_pred)
print(accuracy)

mat_conf_SVM = np.zeros((Nb_classes,Nb_classes))
for i in range (0,XT.shape[0]):
    mat_conf_SVM[YT[i],Y_pred[i]] += 1
    
#print(mat_conf_SVM)


#%% On Olivetti face dataset

faces = datasets.fetch_olivetti_faces()

im = faces.data[0].reshape(64, 64)
plt.figure()
plt.imshow(im)
plt.show()
print(faces.data.shape)

X = faces["data"]
imgs = faces["images"]
y = faces["target"]

# split data randomly into train & test sets by preserving train/test ratio across classes
sss = StratifiedShuffleSplit(n_splits=1, test_size=0.2, random_state=0)
# get the train and test indexes
train_index, test_index = next(sss.split(X, y))

print(test_index)

# split X and y into train & test sets
X_train, X_test = X[train_index], X[test_index]
y_train, y_test = y[train_index], y[test_index]
# Print statistics about it
print(f"Train data size: {len(y_train)}")
print(f"Test data size : {len(y_test)}")

# define the SVM classifier with a Radial Basis Function (RBF) kernel.
classifier = SVC(kernel="rbf", gamma="scale", random_state=0)

# train the classifier and keep track of the time for training.
classifier.fit(X_train, y_train)

#prediction over test data
y_pred = classifier.predict(X_test)

#evlauation of the performance
accuracy = accuracy_score(y_test, y_pred)
print(accuracy)



#%% On test set

plt.close('all')

L = 200;
XA = np.concatenate((np.random.rand(L,2), np.random.rand(L,2)), axis=0)
XA[0:L,1] = XA[0:L,1] + 0.95
YA = np.concatenate((np.zeros(L), np.ones(L))).astype('int')
XT = np.concatenate((np.random.rand(L,2), np.random.rand(L,2)), axis=0)
YT = np.concatenate((np.zeros(L), np.ones(L))).astype('int')

plt.figure()
plt.plot(XA[0:L,0], XA[0:L,1], '*b')
#plt.plot(X1[0:100,0], XT[0:100,1], '.b')
plt.plot(XA[L+1:2*L,0], XA[L+1:2*L,1], '*r')
#plt.plot(XT[101:200,0], XT[101:200,1], '.r')
plt.show()

#%%
#SVM
# define the SVM classifier with a Radial Basis Function (RBF) kernel.
classifier = SVC(C=10000, kernel="rbf", gamma="auto", random_state=0)
#classifier = SVC(C=0.00001, kernel="rbf", gamma="auto", random_state=0)
# train the classifier and keep track of the time for training.
classifier.fit(XA, YA.ravel())
#prediction over test data
Y_pred = classifier.predict(XA)
#evlauation of the performance
accuracy = accuracy_score(YA, Y_pred)
print(accuracy)

mat_conf_SVM = np.zeros((Nb_classes,Nb_classes))
for i in range (0,XT.shape[0]):
    mat_conf_SVM[YT[i],Y_pred[i]] += 1






